diff -ruN vdr-1.3.37/PLUGINS/src/status/HISTORY vdr-1.3.38/PLUGINS/src/status/HISTORY
--- vdr-1.3.37/PLUGINS/src/status/HISTORY	2002-12-13 15:56:50.000000000 +0100
+++ vdr-1.3.38/PLUGINS/src/status/HISTORY	2005-12-31 16:20:19.000000000 +0100
@@ -31,3 +31,7 @@
 2002-12-13: Version 0.1.0
 
 - Changed setting of CXX and CXXFLAGS variables in Makefile.
+
+2005-12-31: Version 0.2.0
+
+- API change in cStatus.
diff -ruN vdr-1.3.37/PLUGINS/src/status/status.c vdr-1.3.38/PLUGINS/src/status/status.c
--- vdr-1.3.37/PLUGINS/src/status/status.c	2002-12-13 16:01:53.000000000 +0100
+++ vdr-1.3.38/PLUGINS/src/status/status.c	2005-12-31 16:19:45.000000000 +0100
@@ -3,13 +3,13 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: status.c 1.7 2002/12/13 15:01:53 kls Exp $
+ * $Id: status.c 1.8 2005/12/31 15:19:45 kls Exp $
  */
 
 #include <vdr/plugin.h>
 #include <vdr/status.h>
 
-static const char *VERSION        = "0.1.0";
+static const char *VERSION        = "0.2.0";
 static const char *DESCRIPTION    = "Status monitor test";
 static const char *MAINMENUENTRY  = NULL;
 
@@ -18,8 +18,8 @@
 class cStatusTest : public cStatus {
 protected:
   virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber);
-  virtual void Recording(const cDevice *Device, const char *Name);
-  virtual void Replaying(const cControl *Control, const char *Name);
+  virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On);
+  virtual void Replaying(const cControl *Control, const char *Name, const char *FileName, bool On);
   virtual void SetVolume(int Volume, bool Absolute);
   virtual void OsdClear(void);
   virtual void OsdTitle(const char *Title);
@@ -36,14 +36,14 @@
   dsyslog("status: cStatusTest::ChannelSwitch  %d %d", Device->CardIndex(), ChannelNumber);
 }
 
-void cStatusTest::Recording(const cDevice *Device, const char *Name)
+void cStatusTest::Recording(const cDevice *Device, const char *Name, const char *FileName, bool On)
 {
-  dsyslog("status: cStatusTest::Recording  %d %s", Device->CardIndex(), Name);
+  dsyslog("status: cStatusTest::Recording  %d %s %s %d", Device->CardIndex(), Name, FileName, On);
 }
 
-void cStatusTest::Replaying(const cControl *Control, const char *Name)
+void cStatusTest::Replaying(const cControl *Control, const char *Name, const char *FileName, bool On)
 {
-  dsyslog("status: cStatusTest::Replaying  %s", Name);
+  dsyslog("status: cStatusTest::Replaying  %s %s %d", Name, FileName, On);
 }
 
 void cStatusTest::SetVolume(int Volume, bool Absolute)
diff -ruN vdr-1.3.37/channels.c vdr-1.3.38/channels.c
--- vdr-1.3.37/channels.c	2005-09-11 16:22:24.000000000 +0200
+++ vdr-1.3.38/channels.c	2005-12-30 16:41:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 1.46 2005/09/11 14:22:24 kls Exp $
+ * $Id: channels.c 1.47 2005/12/30 15:41:24 kls Exp $
  */
 
 #include "channels.h"
@@ -586,7 +586,7 @@
            return p;
         }
      }
-  esyslog("ERROR: illegal value for parameter '%c'", *(s - 1));
+  esyslog("ERROR: invalid value for parameter '%c'", *(s - 1));
   return NULL;
 }
 
diff -ruN vdr-1.3.37/channels.conf vdr-1.3.38/channels.conf
--- vdr-1.3.37/channels.conf	2005-11-27 16:59:18.000000000 +0100
+++ vdr-1.3.38/channels.conf	2006-01-08 12:08:44.000000000 +0100
@@ -2,18 +2,18 @@
 SAT.1;ProSiebenSat.1:12480:vC34:S19.2E:27500:1791:1792=deu;1795=deu:34:0:46:133:33:0
 ProSieben;ProSiebenSat.1:12480:vC34:S19.2E:27500:255:256=deu;257=deu:32:0:898:133:33:0
 RTL2;RTL World:12187:hC34:S19.2E:27500:166:128=deu:68:0:12020:1:1089:0
-Das Erste;ARD:11836:hC34:S19.2E:27500:101:102=deu:104:0:28106:1:1101:0
+Das Erste;ARD:11836:hC34:S19.2E:27500:101:102=deu;106=deu:104:0:28106:1:1101:0
 Bayerisches FS;ARD:11836:hC34:S19.2E:27500:201:202=deu:204:0:28107:1:1101:0
 hr-fernsehen;ARD:11836:hC34:S19.2E:27500:301:302=deu:304:0:28108:1:1101:0
 NDR FS MV;ARD:12109:hC34:S19.2E:27500:2401:2402=deu:2404:0:28224:1:1073:0
 SR SÜDWEST Ferns.;ARD:12265:hC34:S19.2E:27500:1301:1302=deu:1304:0:28486:1:1093:0
 WDR Köln;ARD:11836:hC34:S19.2E:27500:601:602=deu:604:0:28111:1:1101:0
-BR-alpha;ARD:11836:hC34:S19.2E:27500:701:702=deu;703:704:0:28112:1:1101:0
+BR-alpha;ARD:11836:hC34:S19.2E:27500:701:702=deu:704:0:28112:1:1101:0
 SÜDWEST Ferns. BW;ARD:11836:hC34:S19.2E:27500:801:802=deu:804:0:28113:1:1101:0
 Phoenix;ARD:11836:hC34:S19.2E:27500:901:902=deu:904:0:28114:1:1101:0
 ZDF;ZDFvision:11953:hC34:S19.2E:27500:110:120=deu,121=2ch;125=dd:130:0:28006:1:1079:0
 3sat;ZDFvision:11953:hC34:S19.2E:27500:210:220=deu,221=2ch;225=dd:230:0:28007:1:1079:0
-KiKa;ZDFvision:11953:hC34:S19.2E:27500:310:320:0:0:28008:1:1079:0
+KiKa;ZDFvision:11953:hC34:S19.2E:27500:310:320=deu:330:0:28008:1:1079:0
 arte;ARD:11836:hC34:S19.2E:27500:401:402=deu,403=fra:404:0:28109:1:1101:0
 ORF1;ORF:12692:hC56:S19.2E:22000:160:161=deu;163=deu:165:1762,D05,1702,1801:13001:1:1117:0
 ORF2;ORF:12692:hC56:S19.2E:22000:500:501=deu;503=deu:505:1762,D05,1702,1801:13002:1:1117:0
@@ -28,14 +28,14 @@
 HSE24,HSE24;BetaDigital:12480:vC34:S19.2E:27500:1279:1280=deu:37:0:40:133:33:0
 Bloomberg TV Germany;Bloomberg:12551:vC56:S19.2E:22000:162:99=deu:0:0:12160:1:1108:0
 EURONEWS;CSAT:11817:vC34:S19.2E:27500:163:92=fra,93=eng,94=ita,95=esl,91=rus,98=por,99=deu:0:0:8004:1:1070:0
-rbb Brandenburg;ARD:12109:hC34:S19.2E:27500:501:502=deu:504:0:28205:1:1073:0
+rbb Brandenburg;ARD:12109:hC34:S19.2E:27500:601:602=deu:604:0:28205:1:1073:0
 Sky News:11597:vC56:S19.2E:22000:305+131:306=eng:0:0:28707:1:1026:0
 Veronica/JETIX;CANALDIGITAAL:12574:hC56:S19.2E:22000:518+8190:92=dut:38:622,100:5020:53:1109:0
 BVN;CANALDIGITAAL:12574:hC56:S19.2E:22000:515+8190:96=dut:36:0:5025:53:1109:0
 n-tv;RTL World:12187:hC34:S19.2E:27500:169:73=deu:80:0:12090:1:1089:0
 Al Jazeera;CANALSATELLITE:11567:vC56:S19.2E:22000:55:56=ara:0:0:9021:1:1024:0
 TW1;ORF:12662:hC56:S19.2E:22000:1010:1011=deu:1013:0:13101:1:1115:0
-Eurosport;ZDFvision:11953:hC34:S19.2E:27500:410:420=deu:430:0:28009:1:1079:0
+Eurosport;SES Astra:12226:hC34:S19.2E:27500:101+8190:103=deu:102:0:31200:1:1091:0
 EinsExtra;ARD:12109:hC34:S19.2E:27500:101:102=deu:0:0:28201:1:1073:0
 EinsFestival;ARD:12109:hC34:S19.2E:27500:201:202=deu:0:0:28202:1:1073:0
 EinsPlus;ARD:12109:hC34:S19.2E:27500:301:302=deu:0:0:28203:1:1073:0
@@ -44,11 +44,11 @@
 MDR FERNSEHEN;ARD:12109:hC34:S19.2E:27500:401:402=deu:404:0:28204:1:1073:0
 rbb Berlin;ARD:12109:hC34:S19.2E:27500:601:602=deu:604:0:28206:1:1073:0
 :Premiere World
-PREMIERE START,START;PREMIERE:11797:hC34:S19.2E:27500:255:256=deu:32:1:8:133:2:0
-PREMIERE 1,PREM 1;PREMIERE:11797:hC34:S19.2E:27500:511:512=deu,513=deu;515=deu:32:1702,1722,1801:10:133:2:0
-PREMIERE 2,PREM 2;PREMIERE:11797:hC34:S19.2E:27500:1791:1792=deu,1793=deu;1795=deu:32:1702,1801,1722:11:133:2:0
+PREMIERE START,START;PREMIERE:11797:hC34:S19.2E:27500:255:256=deu:32:1801,1722,1702:8:133:2:0
+PREMIERE 1,PREM 1;PREMIERE:11797:hC34:S19.2E:27500:511:512=deu,513=deu;515=deu:32:1801,1722,1702:10:133:2:0
+PREMIERE 2,PREM 2;PREMIERE:11797:hC34:S19.2E:27500:1791:1792=deu,1793=deu;1795=deu:32:1801,1722,1702:11:133:2:0
 PREMIERE 3,PREM 3;PREMIERE:11797:hC34:S19.2E:27500:2303:2304=deu,2305=deu:32:1722,1702,1801:43:133:2:0
-PREMIERE 4,PREM 4;PREMIERE:11797:hC34:S19.2E:27500:767:768=deu:32:1801,1722,1702:9:133:2:0
+PREMIERE 4,PREM 4;PREMIERE:11797:hC34:S19.2E:27500:767:768=deu,769=deu:32:1801,1722,1702:9:133:2:0
 PREMIERE 5,PREM 5;PREMIERE:11797:hC34:S19.2E:27500:1279:1280=deu,1281=deu:32:1722,1702,1801:29:133:2:0
 PREMIERE 6,PREM 6;PREMIERE:11797:hC34:S19.2E:27500:1535:1536=deu:32:1702,1722,1801:41:133:2:0
 PREMIERE 7,PREM 7;PREMIERE:11797:hC34:S19.2E:27500:1023:1024=deu:32:1801,1702,1722:20:133:2:0
@@ -57,10 +57,10 @@
 PREMIERE DIREKT,DIREKT;PREMIERE:12031:hC34:S19.2E:27500:2815:2816=deu,2817=deu;2819=deu:0:0:18:133:4:0
 :PW Erotic
 BEATE-UHSE.TV,B-UHSE;PREMIERE:11758:hC34:S19.2E:27500:1791:1792=deu:32:1722,1702,1801:21:133:17:0
-EROTIK - AB 18!,AB 18!;PREMIERE:12031:hC34:S19.2E:27500:1279:1280=deu:0:1810,1801,1702,1722:513:133:4:0
+EROTIK - AB 18!,AB 18!;PREMIERE:12031:hC34:S19.2E:27500:1279:1280=deu:0:1722,1801,1702,1810:513:133:4:0
 :Sportsworld
-PREMIERE SPORT PORTAL,SPORT PORTAL;PREMIERE:11719:hC34:S19.2E:27500:255:256=deu,257=deu:32:1702,1722,1801:17:133:3:0
-PREMIERE WIN,WIN;PREMIERE:12031:hC34:S19.2E:27500:3839:3840=deu:32:0:27:133:4:0
+PREMIERE SPORT PORTAL,SPORT PORTAL;PREMIERE:11719:hC34:S19.2E:27500:255:256=deu,257=deu:32:1722,1801,1702:17:133:3:0
+PREMIERE WIN,WIN;PREMIERE:12031:hC34:S19.2E:27500:3839:3840=deu:33:0:27:133:4:0
 :Beta Digital
 N24;ProSiebenSat.1:12480:vC34:S19.2E:27500:2047:2048=deu:36:0:47:133:33:0
 LibertyTV FR;LibertyTV.com:12610:vC56:S19.2E:22000:941:943=deu:0:0:12199:1:1112:0
@@ -92,9 +92,9 @@
 Sky Two;BSkyB:12226:hC23:S28.2E:27500:514+8190:642=eng,662=NAR:578:960,961:5104:2:2027:0
 ITV2;BSkyB:10758:vC56:S28.2E:22000:2314:2315=eng,2363=NAR:2317:0:10070:2:2044:0
 Sci-Fi;BSkyB:12148:hC23:S28.2E:27500:512+8190:640=eng:576:960,961:4905:2:2023:0
-Paramount;BSkyB:12187:hC23:S28.2E:27500:518+8190:666=eng,686=NAR:582:960,961:5904:2:2025:0
+ParaComedy 1;BSkyB:12187:hC23:S28.2E:27500:518+8190:666=eng,686=NAR:582:960,961:5904:2:2025:0
 Paramount;BSkyB:11526:vC23:S28.2E:27500:2317+2306:2318=eng:2319:960,961:50305:2:2404:0
-Paramount 2;BSkyB:11914:hC23:S28.2E:27500:514+8190:642=eng,662=NAR:578:960,961:4504:2:2011:0
+ParaComedy 2;BSkyB:11914:hC23:S28.2E:27500:514+8190:642=eng,662=NAR:578:960,961:4504:2:2011:0
 Discovery;BSkyB:11875:hC23:S28.2E:27500:2308:2310=eng,2311=NAR:2309:960,961:6201:2:2009:0
 Sky Movies 1;BSkyB:11836:hC23:S28.2E:27500:518+8190:646=eng,653=NAR;686=eng:582:960,961:4303:2:2007:0
 Sky Movies 2;BSkyB:11836:hC23:S28.2E:27500:519+8190:647=eng,667=NAR;687=eng:583:960,961:4302:2:2007:0
@@ -115,8 +115,11 @@
 CNN;BSkyB:12051:vC23:S28.2E:27500:2313:2315=eng:2314:0:7140:2:2018:0
 BBC PARL'MNT;BSkyB:10847:vC56:S28.2E:22000:2327:2328=eng:2331:0:6902:2:2050:0
 IGLESIA MME;T-Systems/MTI:11200:vC56:S13.0E:27500:4097:4098:0:0:4733:318:13400:0
-Euro1080;EURO1080:12168:vC56:S19.2E:27500:308:256:0:FF:21100:1:1088:0
-Astra HD:12441:vC34:S19.2E:27500:133+80:134=eng:0:FF:29700:0:0:0
+Euro1080 HD-5;Euro1080:10758:vC78:S23.5E:22000:34:160=eng:0:0:1085:9999:3104:0
+Euro1080;EURO1080:12168:vC56:S19.2E:27500:308:256:0:0:21100:1:1088:0
+SMD HD;SES ASTRA:12699:vC56:S19.2E:22000:133+80:234=eng:0:0:29700:0:0:0
+Astra HD:12441:vC34:S19.2E:27500:133+80:134=eng:0:0:29700:0:0:0
 eng-WRN-multi;WRN:12597:vC34:S13.0E:27500:0:2132:0:0:8230:318:9400:0
-TVS Teleport Bonn;DMV:11535:vC34:S1.0W:5632:308+8190:256=eng,257=eng:0:2:1:65535:1:0
+Challenger Tv;Telespazio:11304:hC34:S13.0E:27500:490:491:0:0:8409:318:500:0
+TVS Teleport Bonn;DMV:11535:vC34:S1.0W:5632:308+8190:256=eng,257=eng:0:3:1:65535:1:0
 :@1000 New channels
diff -ruN vdr-1.3.37/channels.h vdr-1.3.38/channels.h
--- vdr-1.3.37/channels.h	2005-09-17 11:59:14.000000000 +0200
+++ vdr-1.3.38/channels.h	2006-01-07 14:00:43.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.h 1.36 2005/09/17 09:59:14 kls Exp $
+ * $Id: channels.h 1.37 2006/01/07 13:00:43 kls Exp $
  */
 
 #ifndef __CHANNELS_H
@@ -39,6 +39,14 @@
 #define MAXLANGCODE1 4 // a 3 letter language code, zero terminated
 #define MAXLANGCODE2 8 // up to two 3 letter language codes, separated by '+' and zero terminated
 
+#define CA_FTA           0x0000
+#define CA_DVB_MIN       0x0001
+#define CA_DVB_MAX       0x000F
+#define CA_USER_MIN      0x0010
+#define CA_USER_MAX      0x00FF
+#define CA_ENCRYPTED_MIN 0x0100
+#define CA_ENCRYPTED_MAX 0xFFFF
+
 struct tChannelParameterMap {
   int userValue;
   int driverValue;
diff -ruN vdr-1.3.37/ci.c vdr-1.3.38/ci.c
--- vdr-1.3.37/ci.c	2005-11-26 14:36:51.000000000 +0100
+++ vdr-1.3.38/ci.c	2006-01-07 16:07:16.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.c 1.40 2005/11/26 13:36:51 kls Exp $
+ * $Id: ci.c 1.42 2006/01/07 15:07:16 kls Exp $
  */
 
 #include "ci.h"
@@ -185,7 +185,7 @@
             size = 6;
             }
          else
-            esyslog("ERROR: illegal data length for TPDU tag 0x%02X: %d", Tag, Length);
+            esyslog("ERROR: invalid data length for TPDU tag 0x%02X: %d", Tag, Length);
          break;
     case T_DATA_LAST:
     case T_DATA_MORE:
@@ -198,7 +198,7 @@
             size = Length + (p - data);
             }
          else
-            esyslog("ERROR: illegal data length for TPDU tag 0x%02X: %d", Tag, Length);
+            esyslog("ERROR: invalid data length for TPDU tag 0x%02X: %d", Tag, Length);
          break;
     default:
          esyslog("ERROR: unknown TPDU tag: 0x%02X", Tag);
@@ -1639,6 +1639,15 @@
   return result;
 }
 
+int cCiHandler::NumCams(void)
+{
+  int result = 0;
+  for (int i = 0; i < MAX_CI_SLOT; i++)
+      if (moduleReady[i])
+         result++;
+  return result;
+}
+
 bool cCiHandler::Ready(void)
 {
   cMutexLock MutexLock(&mutex);
diff -ruN vdr-1.3.37/ci.h vdr-1.3.38/ci.h
--- vdr-1.3.37/ci.h	2005-11-26 14:37:42.000000000 +0100
+++ vdr-1.3.38/ci.h	2006-01-07 16:03:05.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.h 1.19 2005/11/26 13:37:42 kls Exp $
+ * $Id: ci.h 1.21 2006/01/07 15:03:05 kls Exp $
  */
 
 #ifndef __CI_H
@@ -112,6 +112,7 @@
   cList<cCiCaProgramData> caProgramList;
   int ResourceIdToInt(const uint8_t *Data);
   bool Send(uint8_t Tag, int SessionId, int ResourceId = 0, int Status = -1);
+  const unsigned short *GetCaSystemIds(int Slot);
   cCiSession *GetSessionBySessionId(int SessionId);
   cCiSession *GetSessionByResourceId(int ResourceId, int Slot);
   cCiSession *CreateSession(int ResourceId);
@@ -123,18 +124,35 @@
 public:
   ~cCiHandler();
   static cCiHandler *CreateCiHandler(const char *FileName);
+       ///< Creates a new cCiHandler for the given CA device.
   int NumSlots(void) { return numSlots; }
+       ///< Returns the number of CAM slots provided by this CA device.
+  int NumCams(void);
+       ///< Returns the number of actual CAMs inserted into this CA device.
   bool Ready(void);
+       ///< Returns true if all CAMs in this CA device are ready.
   bool Process(int Slot = -1);
        ///< Processes the given Slot. If Slot is -1, all slots are processed.
        ///< Returns false in case of an error.
   bool HasUserIO(void) { return hasUserIO; }
+       ///< Returns true if there is a pending user interaction, which shall
+       ///< be retrieved via GetMenu() or GetEnquiry().
   bool EnterMenu(int Slot);
+       ///< Requests the CAM in the given Slot to start its menu.
   cCiMenu *GetMenu(void);
+       ///< Gets a pending menu, or NULL if there is no menu.
   cCiEnquiry *GetEnquiry(void);
+       ///< Gets a pending enquiry, or NULL if there is no enquiry.
   const char *GetCamName(int Slot);
-  const unsigned short *GetCaSystemIds(int Slot);
+       ///< Returns the name of the CAM in the given Slot, or NULL if there
+       ///< is no CAM in that slot.
   bool ProvidesCa(const unsigned short *CaSystemIds); //XXX Slot???
+       ///< Returns true if any of the CAMs can provide one of the given
+       ///< CaSystemIds. This doesn't necessarily mean that it will be
+       ///< possible to actually decrypt such a programme, since CAMs
+       ///< usually advertise several CA system ids, while the actual
+       ///< decryption is controlled by the smart card inserted into
+       ///< the CAM.
   void SetSource(int Source, int Transponder);
        ///< Sets the Source and Transponder of the device this cCiHandler is
        ///< currently tuned to. If Source or Transponder are different than
@@ -145,11 +163,14 @@
        ///< to SetPid() will (de)activate one of these entries.
   void SetPid(int Pid, bool Active);
        ///< Sets the given Pid (which has previously been added through a
-       ///< call to AddPid()) to Active. If Active is true, a later call to
-       ///< StartDecrypting() will send the full list of currently active CA_PMT
-       ///< entries to the CAM, including this one.
+       ///< call to AddPid()) to Active. A later call to StartDecrypting() will
+       ///< send the full list of currently active CA_PMT entries to the CAM.
   bool CanDecrypt(int ProgramNumber);
        ///< XXX
+       ///< Returns true if there is a CAM in this CA device that is able
+       ///< to decrypt the programme with the given ProgramNumber. The PIDs
+       ///< for this ProgramNumber must have been set through previous calls
+       ///< to SetPid().
   void StartDecrypting(void);
        ///< Triggers sending all currently active CA_PMT entries to the CAM,
        ///< so that it will start decrypting.
diff -ruN vdr-1.3.37/config.c vdr-1.3.38/config.c
--- vdr-1.3.37/config.c	2005-09-09 17:08:59.000000000 +0200
+++ vdr-1.3.38/config.c	2006-01-07 13:28:49.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 1.138 2005/09/09 15:08:59 kls Exp $
+ * $Id: config.c 1.140 2006/01/07 12:28:49 kls Exp $
  */
 
 #include "config.h"
@@ -120,24 +120,6 @@
   return (Address & mask) == addr.s_addr;
 }
 
-// -- cCaDefinition ----------------------------------------------------------
-
-cCaDefinition::cCaDefinition(void)
-{
-  number = 0;
-  description = NULL;
-}
-
-cCaDefinition::~cCaDefinition()
-{
-  free(description);
-}
-
-bool cCaDefinition::Parse(const char *s)
-{
-  return 2 == sscanf(s, "%d %a[^\n]", &number, &description) && description && *description;
-}
-
 // -- cCommands --------------------------------------------------------------
 
 cCommands Commands;
@@ -158,21 +140,6 @@
   return false;
 }
 
-// -- cCaDefinitions ---------------------------------------------------------
-
-cCaDefinitions CaDefinitions;
-
-const cCaDefinition *cCaDefinitions::Get(int Number)
-{
-  cCaDefinition *p = First();
-  while (p) {
-        if (p->Number() == Number)
-           return p;
-        p = (cCaDefinition *)p->Next();
-        }
-  return NULL;
-}
-
 // -- cSetupLine -------------------------------------------------------------
 
 cSetupLine::cSetupLine(void)
@@ -250,6 +217,7 @@
   strcpy(OSDTheme, "default");
   PrimaryDVB = 1;
   ShowInfoOnChSwitch = 1;
+  TimeoutRequChInfo = 1;
   MenuScrollPage = 1;
   MenuScrollWrap = 0;
   MarkInstantRecord = 1;
@@ -408,6 +376,7 @@
   else if (!strcasecmp(Name, "OSDTheme"))            strn0cpy(OSDTheme, Value, MaxThemeName);
   else if (!strcasecmp(Name, "PrimaryDVB"))          PrimaryDVB         = atoi(Value);
   else if (!strcasecmp(Name, "ShowInfoOnChSwitch"))  ShowInfoOnChSwitch = atoi(Value);
+  else if (!strcasecmp(Name, "TimeoutRequChInfo"))   TimeoutRequChInfo  = atoi(Value);
   else if (!strcasecmp(Name, "MenuScrollPage"))      MenuScrollPage     = atoi(Value);
   else if (!strcasecmp(Name, "MenuScrollWrap"))      MenuScrollWrap     = atoi(Value);
   else if (!strcasecmp(Name, "MarkInstantRecord"))   MarkInstantRecord  = atoi(Value);
@@ -473,6 +442,7 @@
   Store("OSDTheme",           OSDTheme);
   Store("PrimaryDVB",         PrimaryDVB);
   Store("ShowInfoOnChSwitch", ShowInfoOnChSwitch);
+  Store("TimeoutRequChInfo",  TimeoutRequChInfo);
   Store("MenuScrollPage",     MenuScrollPage);
   Store("MenuScrollWrap",     MenuScrollWrap);
   Store("MarkInstantRecord",  MarkInstantRecord);
diff -ruN vdr-1.3.37/config.h vdr-1.3.38/config.h
--- vdr-1.3.37/config.h	2005-11-11 14:22:02.000000000 +0100
+++ vdr-1.3.38/config.h	2006-01-07 13:57:42.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.235 2005/11/11 13:22:02 kls Exp $
+ * $Id: config.h 1.238 2006/01/07 12:57:42 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -19,8 +19,8 @@
 #include "i18n.h"
 #include "tools.h"
 
-#define VDRVERSION  "1.3.37"
-#define VDRVERSNUM   10337  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.3.38"
+#define VDRVERSNUM   10338  // Version * 10000 + Major * 100 + Minor
 
 #define MAXPRIORITY 99
 #define MAXLIFETIME 99
@@ -61,20 +61,6 @@
   bool Accepts(in_addr_t Address);
   };
 
-#define CACONFBASE 100
-
-class cCaDefinition : public cListObject {
-private:
-  int number;
-  char *description;
-public:
-  cCaDefinition(void);
-  ~cCaDefinition();
-  bool Parse(const char *s);
-  int Number(void) const { return number; }
-  const char *Description(void) const { return description; }
-  };
-
 template<class T> class cConfig : public cList<T> {
 private:
   char *fileName;
@@ -166,15 +152,9 @@
   bool Acceptable(in_addr_t Address);
   };
 
-class cCaDefinitions : public cConfig<cCaDefinition> {
-public:
-  const cCaDefinition *Get(int Number);
-  };
-
 extern cCommands Commands;
 extern cCommands RecordingCommands;
 extern cSVDRPhosts SVDRPhosts;
-extern cCaDefinitions CaDefinitions;
 
 class cSetupLine : public cListObject {
 private:
@@ -210,6 +190,7 @@
   char OSDTheme[MaxThemeName];
   int PrimaryDVB;
   int ShowInfoOnChSwitch;
+  int TimeoutRequChInfo;
   int MenuScrollPage;
   int MenuScrollWrap;
   int MarkInstantRecord;
diff -ruN vdr-1.3.37/device.c vdr-1.3.38/device.c
--- vdr-1.3.37/device.c	2005-11-26 13:56:09.000000000 +0100
+++ vdr-1.3.38/device.c	2006-01-08 12:39:37.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 1.112 2005/11/26 12:56:09 kls Exp $
+ * $Id: device.c 1.121 2006/01/08 11:39:37 kls Exp $
  */
 
 #include "device.h"
@@ -222,7 +222,7 @@
         esyslog("ERROR: nextCardIndex too big (%d)", nextCardIndex);
      }
   else if (n < 0)
-     esyslog("ERROR: illegal value in IncCardIndex(%d)", n);
+     esyslog("ERROR: invalid value in IncCardIndex(%d)", n);
   return nextCardIndex;
 }
 
@@ -302,7 +302,7 @@
             pri = 6; // receiving with same priority but fewer Ca's
          else
             pri = 7; // all others
-         if (pri < select) {
+         if (pri <= select) {
             select = pri;
             d = device[i];
             if (NeedsDetachReceivers)
@@ -322,9 +322,36 @@
       }
 }
 
-bool cDevice::GrabImage(const char *FileName, bool Jpeg, int Quality, int SizeX, int SizeY)
+uchar *cDevice::GrabImage(int &Size, bool Jpeg, int Quality, int SizeX, int SizeY)
 {
-  return false;
+  return NULL;
+}
+
+bool cDevice::GrabImageFile(const char *FileName, bool Jpeg, int Quality, int SizeX, int SizeY)
+{
+  int result = 0;
+  int fd = open(FileName, O_WRONLY | O_CREAT | O_NOFOLLOW | O_TRUNC, DEFFILEMODE);
+  if (fd >= 0) {
+     int ImageSize;
+     uchar *Image = GrabImage(ImageSize, Jpeg, Quality, SizeX, SizeY);
+     if (Image) {
+        if (safe_write(fd, Image, ImageSize) == ImageSize)
+           isyslog("grabbed image to %s", FileName);
+        else {
+           LOG_ERROR_STR(FileName);
+           result |= 1;
+           }
+        free(Image);
+        }
+     else
+        result |= 1;
+     close(fd);
+     }
+  else {
+     LOG_ERROR_STR(FileName);
+     result |= 1;
+     }
+  return result == 0;
 }
 
 void cDevice::SetVideoDisplayFormat(eVideoDisplayFormat VideoDisplayFormat)
@@ -577,10 +604,14 @@
   if (LiveView)
      StopReplay();
 
+  // If this card is switched to an other transponder, any receivers still
+  // attached to it ineed to be automatically detached:
+  bool NeedsDetachReceivers = false;
+
   // If this card can't receive this channel, we must not actually switch
   // the channel here, because that would irritate the driver when we
   // start replaying in Transfer Mode immediately after switching the channel:
-  bool NeedsTransferMode = (LiveView && IsPrimaryDevice() && !ProvidesChannel(Channel, Setup.PrimaryLimit));
+  bool NeedsTransferMode = (LiveView && IsPrimaryDevice() && !ProvidesChannel(Channel, Setup.PrimaryLimit, &NeedsDetachReceivers));
 
   eSetChannelResult Result = scrOk;
 
@@ -588,11 +619,14 @@
   // use the card that actually can receive it and transfer data from there:
 
   if (NeedsTransferMode) {
-     cDevice *CaDevice = GetDevice(Channel, 0);
+     cDevice *CaDevice = GetDevice(Channel, 0, &NeedsDetachReceivers);
      if (CaDevice && CanReplay()) {
         cStatus::MsgChannelSwitch(this, 0); // only report status if we are actually going to switch the channel
-        if (CaDevice->SetChannel(Channel, false) == scrOk) // calling SetChannel() directly, not SwitchChannel()!
+        if (CaDevice->SetChannel(Channel, false) == scrOk) { // calling SetChannel() directly, not SwitchChannel()!
+           if (NeedsDetachReceivers)
+              CaDevice->DetachAllReceivers();
            cControl::Launch(new cTransferControl(CaDevice, Channel->Vpid(), Channel->Apids(), Channel->Dpids(), Channel->Spids()));
+           }
         else
            Result = scrNoTransfer;
         }
@@ -613,7 +647,7 @@
         ciHandler->SetSource(Channel->Source(), Channel->Transponder());
 // Men at work - please stand clear! ;-)
 #ifdef XXX_DO_MULTIPLE_CA_CHANNELS
-        if (Channel->Ca() > CACONFBASE) {
+        if (Channel->Ca() >= CA_ENCRYPTED_MIN) {
 #endif
            ciHandler->AddPid(Channel->Sid(), Channel->Vpid(), 2);
            for (const int *Apid = Channel->Apids(); *Apid; Apid++)
@@ -626,13 +660,15 @@
            }
 #endif
         }
+     if (NeedsDetachReceivers)
+        DetachAllReceivers();
      if (SetChannelDevice(Channel, LiveView)) {
         // Start section handling:
         if (sectionHandler) {
            sectionHandler->SetChannel(Channel);
            sectionHandler->SetStatus(true);
            }
-        // Start decrypting any PIDs the might have been set in SetChannelDevice():
+        // Start decrypting any PIDs that might have been set in SetChannelDevice():
         if (ciHandler)
            ciHandler->StartDecrypting();
         }
@@ -794,6 +830,7 @@
 bool cDevice::SetCurrentAudioTrack(eTrackType Type)
 {
   if (ttNone < Type && Type < ttDolbyLast) {
+     cMutexLock MutexLock(&mutexCurrentAudioTrack);
      if (IS_DOLBY_TRACK(Type))
         SetDigitalAudioDevice(true);
      currentAudioTrack = Type;
@@ -947,6 +984,7 @@
 
 int cDevice::PlayPesPacket(const uchar *Data, int Length, bool VideoOnly)
 {
+  cMutexLock MutexLock(&mutexCurrentAudioTrack);
   bool FirstLoop = true;
   uchar c = Data[3];
   const uchar *Start = Data;
@@ -972,7 +1010,7 @@
                uchar SubStreamId = Data[PayloadOffset];
                uchar SubStreamType = SubStreamId & 0xF0;
                uchar SubStreamIndex = SubStreamId & 0x1F;
-        
+
                // Compatibility mode for old VDR recordings, where 0xBD was only AC3:
 pre_1_3_19_PrivateStreamDeteced:
                if (pre_1_3_19_PrivateStream) {
@@ -1111,7 +1149,7 @@
   int Ca = Channel->Ca();
   if (Ca == CardIndex() + 1)
      return 1; // exactly _this_ card was requested
-  if (Ca && Ca <= MAXDEVICES)
+  if (Ca && Ca <= CA_DVB_MAX)
      return 0; // a specific card was requested, but not _this_ one
   return !Ca; // by default every card can provide FTA
 }
@@ -1242,6 +1280,15 @@
      }
 }
 
+void cDevice::DetachAllReceivers(void)
+{
+  cMutexLock MutexLock(&mutexReceiver);
+  for (int i = 0; i < MAXRECEIVERS; i++) {
+      if (receiver[i])
+         Detach(receiver[i]);
+      }
+}
+
 // --- cTSBuffer -------------------------------------------------------------
 
 cTSBuffer::cTSBuffer(int File, int Size, int CardIndex)
